function [f]=barycentric(x,y,z)
n = length(x);
w = ones(1,n);
for j = 1:n
    for k = 1:j-1
        w(j) = w(j)*(x(j)-x(k));
    end
    for k = j+1:n
        w(j) = w(j)*(x(j)-x(k));
    end
end
w = 1./w;
nz = length(z);
for i = 1:nz
    j = find(z(i)==x);
    if ~isempty(j)
        f(i) = y(j);
    else
        f(i) = sum(y.*w./(z(i)-x))/sum(w./(z(i)-x));
    end
end
return